jQuery(document).ready(function () {
    _.each(qmn_quiz_data, function (quiz) {
        let quiz_id = parseInt(quiz.quiz_id);
        
        //sets the started time of quiz to localStorage
        if ( qmn_quiz_data[quiz_id].hasOwnProperty('advanced_timer') && qmn_quiz_data[quiz_id].advanced_timer.timer_continues_after_closing == 'yes' && localStorage.getItem("begins_at_quiz" +quiz_id) == null ) {        
            localStorage.setItem("begins_at_quiz" +quiz_id, new Date().getTime());
        }
        
        let current_page_status = localStorage.getItem("qsm_quiz_current_page_" + quiz_id);
        
        if ( qmn_quiz_data[quiz_id].advanced_timer.timer_continues_per_page == 'yes' && current_page_status ) {
            _.each(qmn_quiz_data[quiz_id].qpages, function ( qpage ) {
                if( localStorage.getItem("qsm_quiz_current_page_started_at_" + quiz_id + "page_" + qpage.id) && qpage.pagetimer != 0 ) {
                    let started_time = localStorage.getItem("qsm_quiz_current_page_started_at_" + quiz_id + "page_" + qpage.id);
                    let timeDiff = Math.round((new Date().getTime() - started_time) / 1000);
                    let pageTime = qpage.pagetimer * 60;
                    let finalRemainingTime = pageTime - timeDiff;
                    if( undefined != pageTime && finalRemainingTime > 0) {
                        qpage.timerRemaning = finalRemainingTime;
                    } else {
                        qpage.timerRemaning = 1;
                    }
                }
            })            
        }

        if( localStorage.getItem("begins_at_quiz" +quiz_id) !== undefined && qmn_quiz_data[quiz_id].advanced_timer.timer_continues_after_closing == 'yes' ) {        
            let quizBeginTime = parseInt(localStorage.getItem("begins_at_quiz" +quiz_id));
            let timeDifference = Math.round((new Date().getTime() - quizBeginTime) / 1000 );    
            let finalRemainingTime = qmn_quiz_data[quiz_id].timer_limit * 60 - timeDifference;
            
            if( finalRemainingTime > 0 ) {
                localStorage.setItem("mlw_time_quiz" + quiz_id, finalRemainingTime);
            } else {
                localStorage.setItem("mlw_time_quiz" + quiz_id, 1);
            }
        }
    });

    jQuery(document).on('qsm_init_page_timer_after', function(event, quiz_id, $currentpage){
        var pageId = $currentpage.data('pid');        
        if ( qmn_quiz_data[quiz_id].advanced_timer.timer_continues_per_page == 'yes' 
            && undefined != pageId ) {
            localStorage.setItem("qsm_quiz_current_page_" + quiz_id,  pageId);
            if(localStorage.getItem("qsm_quiz_current_page_started_at_" + quiz_id + "page_" + pageId) == null
                && qmn_quiz_data[quiz_id].qpages[pageId].pagetimer != null){
                localStorage.setItem("qsm_quiz_current_page_started_at_" + quiz_id + "page_" + pageId,  new Date().getTime());
            }
        }
    });

    jQuery(document).on('qsm_before_form_data_process', function (event, quiz_form_id, unindexed_array) {
        let quiz_id = quiz_form_id.replace("quizForm", "");
	    let timer_ms = new Date().getTime();
        let started_time = localStorage.getItem("begins_at_quiz" + quiz_id);
        if( qmn_quiz_data[quiz_id].advanced_timer.timer_continues_after_closing == 'yes' && started_time ) {
            let time_taken = Math.round( Math.abs(started_time - timer_ms) / 1000 );
            _.each(unindexed_array, function ( item ) {
                if( item.name == 'timer') {
                    item.value = time_taken;
                }
            })
        }
    })

    //Unset the started time of quiz to localStorage after quiz submission
    jQuery(document).on('qsm_after_quiz_submit', function (event, quiz_form_id) {
        let quiz_id = quiz_form_id.replace("quizForm", "");
        localStorage.removeItem("begins_at_quiz" +quiz_id);
        localStorage.removeItem("qsm_quiz_current_page_" + quiz_id);
        _.each(qmn_quiz_data[quiz_id].qpages, function ( qpage ) {
            localStorage.removeItem("qsm_quiz_current_page_started_at_" + quiz_id + "page_" + qpage.id);
            localStorage.removeItem('time_taken_' + quiz_id + '_page' + qpage.id);
        })
    });

   jQuery('.stoptimer').click(function (e) {
       e.preventDefault(); 
       MicroModal.show( 'stop-timer-popup' );
       var quiz_id = jQuery("#qmn_quiz_id").val();
       QSM.endTimer( quiz_id );
       clearInterval(qsmTimerInterval[quiz_id]);
       QSMPageTimer.endPageTimer(quiz_id);
   });
   
   //Submit the form on popup click
   jQuery('.stop-timer-submit-the-form').click(function(e){
       e.preventDefault();
       var quiz_id = jQuery("#qmn_quiz_id").val();
       qsmEndTimeTakenTimer();
       QSM.endTimer( quiz_id );
       jQuery('#quizForm' + quiz_id ).submit();
       jQuery('#stop-timer-popup').removeClass('is-open');
   });

   jQuery('.stop-timer-continue-the-quiz').click(function(e){
       e.preventDefault();
       var quizID = jQuery("#qmn_quiz_id").val();
       qmn_quiz_data[quizID].timerInterval = setInterval(QSM.timer, 1000, quizID);
       qsmTimerInterval[quizID] = setInterval(function () { qmnTimeTakenTimer(quizID) }, 1000);
       jQuery('#stop-timer-popup').removeClass('is-open');
   });
   //Check stop timer div
   if(jQuery('.stoptimer-p').length > 0){        
       jQuery('.stoptimer-p').parents('.qsm-quiz-container').addClass('qsm-stop-timer-enabled');
   }
   
   jQuery('.pagetime-goto-nextslide').click(function (e) {
        e.preventDefault();
        var quiz_id = jQuery(this).data('quiz_id');
        var $apid = jQuery('.qsm-auto-page-row:visible').data('apid');
        var maxDataapid = 0;
        jQuery('.qsm-auto-page-row').each(function() {
            var dataapid = jQuery(this).data('apid');
            if(maxDataapid < dataapid) {
                maxDataapid = dataapid;
            }
        });
        if(maxDataapid != $apid){
            qmnNextSlide($apid + 1, 1, '#quizForm' + quiz_id);
            advanceAutoPageTimerContinue(quiz_id);
        }
    });

   jQuery(document).on('qsm_next_button_click_after qsm_previous_button_click_after', function (event, quizID) {
        advanceAutoPageTimerContinue(quizID);
   });
});

function advanceAutoPageTimerContinue(quizID){
    var $currentpage = jQuery('.qsm-auto-page-row:visible');
    var $apid = jQuery('.qsm-auto-page-row:visible').data('apid');
    jQuery('.qsm-auto-page-row').each(function() {
        var dataapid = jQuery(this).data('apid');
        if (typeof dataapid !== 'undefined' && qmn_quiz_data[quizID] && qmn_quiz_data[quizID].qpages && qmn_quiz_data[quizID].qpages[dataapid] && typeof qmn_quiz_data[quizID].qpages[dataapid].timerInterval !== 'undefined') {
            clearInterval(qmn_quiz_data[quizID].qpages[dataapid].timerInterval);
        }
    });
    if( qmn_quiz_data[quizID].hasOwnProperty('advance_per_page_timer') && undefined != $apid &&  0 < qmn_quiz_data[quizID].advance_per_page_timer && qmn_quiz_data[quizID].hasOwnProperty('pagination') && 0 < qmn_quiz_data[quizID].pagination.amount ) {
        var $timer_box = $currentpage.find('.qsm-pagetimer');
        var seconds = 0;
        var timerTaken = localStorage.getItem('time_taken_' + quizID + '_page' + $apid);
        var per_page_timer_second = parseInt(qmn_quiz_data[quizID].advance_per_page_timer) * 60;
        if( timerTaken >= qmn_quiz_data[quizID].advance_per_page_timer ){
            seconds = per_page_timer_second - parseInt(timerTaken);
        }else if( timerTaken <= qmn_quiz_data[quizID].advance_per_page_timer && null != timerTaken ){
            seconds = per_page_timer_second - parseInt(timerTaken);
        }else{
            seconds = per_page_timer_second;
            localStorage.setItem('time_taken_' + quizID + '_page' + $apid, 0);
        }
        $timer_box.show();
        $timer_box.text(advanceAutoPageTimerDisplay(seconds, $apid, quizID));
        /* Sets up timer interval. */
        qmn_quiz_data[quizID].qpages[$apid].timerInterval = setInterval(advanceAutoPageTimer, 1000, quizID, $apid, $timer_box);
    }
}

function advanceAutoPageTimerDisplay(seconds, current_page, quiz_id) {
    var formattedTime = '';
    seconds = parseInt(seconds);
    var hours = Math.floor(seconds / 3600);
    if (0 === hours) {
        formattedTime = '00:';
    } else if (10 > hours) {
        formattedTime = '0' + hours + ':';
    } else {
        formattedTime = hours + ':';
    }
    var minutes = Math.floor((seconds % 3600) / 60);
    if (0 === minutes) {
        formattedTime = formattedTime + '00:';
    } else if (10 > minutes) {
        formattedTime = formattedTime + '0' + minutes + ':';
    } else {
        formattedTime = formattedTime + minutes + ':';
    }
    var remainder = Math.floor((seconds % 60));
    if (0 === remainder) {
        formattedTime = formattedTime + '00';
    } else if (10 > remainder) {
        formattedTime = formattedTime + '0' + remainder;
    } else {
        formattedTime = formattedTime + remainder;
    }
    return formattedTime;
}

function advanceAutoPageTimer(quizID, $apid, $timer_box) {
    var timerTaken = localStorage.getItem('time_taken_' + quizID + '_page' + $apid);
    var per_page_timer_second = parseInt(qmn_quiz_data[quizID].advance_per_page_timer) * 60;
    seconds = per_page_timer_second - parseInt(timerTaken);
    if( 0 < seconds) {
        timerTaken++;
        seconds--;
        localStorage.setItem('time_taken_' + quizID + '_page' + $apid, timerTaken);
        $timer_box.text(advanceAutoPageTimerDisplay(seconds, $apid, quizID));
    }else{
        $timer_box.text(advanceAutoPageTimerDisplay(0, $apid, quizID));
        clearInterval(qmn_quiz_data[quizID].qpages[$apid].timerInterval);
        MicroModal.show('modal-page-1');
    }
}
